<?php
/**
 * {{ namespace }}\Model\Table\{{ name }}Table
 */

namespace {{ namespace }}\Model\Table;
{{- "\n\n" }}
{%- for behavior, behaviorData in behaviors %}
use Cake\ORM\Behavior\{{ behavior }}Behavior;
{% endfor %}
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Table {{ name|preg_replace('/(.)([A-Z])/', '$1_$2')|lower }}
 *
 * @category Table
 *
 * @author    Libriciel SCOP <contact@libriciel.coop>
* @copyright (c) {{ "now"|date("Y") }}, Libriciel
* @license   https://www.gnu.org/licenses/agpl-3.0.txt{{- "\n" }}
{%- for behavior, behaviorData in behaviors %}
    * @mixin {{ behavior }}Behavior
{% endfor %}
*/
class {{ name }}Table extends Table
{

/**
* Configuration initale de la table
* @param array $config
*/
public function initialize(array $config): void
{
parent::initialize($config);{{- "\n" }}

{%- for behavior, behaviorData in behaviors %}
    $this->addBehavior('{{ behavior }}'{{ (behaviorData ? (", [" ~ Bake.stringifyList(behaviorData, {'indent': 3, 'quotes': false})|raw ~ ']') : '')|raw }});{{- "\n" }}
{% endfor %}

{%- for type, assocs in associations %}
    {%- for assoc in assocs %}
        {%- set assocData = [] %}
        {%- for key, val in assoc %}
            {%- if key is not same as('alias') %}
                {%- set assocData = assocData|merge({(key): val}) %}
            {%- endif %}
        {%- endfor %}
        $this->{{ type }}('{{ assoc.alias }}', [{{ Bake.stringifyList(assocData, {'indent': 3})|raw }}]);
        {{- "\n" }}
    {%- endfor %}
{% endfor %}
}
{{- "\n" }}

{%- if validation %}

    /**
    * Default validation rules.
    * @param Validator $validator Validator instance.
    * @return Validator
    */
    public function validationDefault(Validator $validator): Validator
    {
    {% for field, rules in validation %}
        {% set validationMethods = Bake.getValidationMethods(field, rules) %}
        {% if validationMethods %}
            $validator
            {% for validationMethod in validationMethods %}
                {% if loop.last %}
                    {% set validationMethod = validationMethod ~ ';' %}
                {% endif %}
                {{ validationMethod|raw }}
            {% endfor %}

        {% endif %}
    {% endfor %}
    return $validator;
    }
{% endif %}

{%- if connection is not same as('default') %}

    /**
    * Returns the database connection name to use by default.
    * @return string
    */
    public static function defaultConnectionName()
    {
    return '{{ connection }}';
    }
{% endif %}
}
